package 
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;	
	import flash.events.MouseEvent;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.media.Camera;
	import flash.media.Video;
	
	public class Main extends Sprite 
	{
		// video stuff
		private var camW:int = 300;
		private var camH:int = 300;
		private var video:Video;
		
		// block stuff
		private var rows:int = 3;
		private var cols:int = 3;
		private var blockW:int = camW/cols;
		private var blockH:int = camH/rows;
		private var pointArray:Array = new Array();
		
		public function Main():void {
			var camera:Camera = Camera.getCamera();
			camera.setMode(camW, camH, 30);
			video = new Video(camW, camH);
			video.attachCamera(camera);
			
			initBlocks();
			addEventListener(Event.ENTER_FRAME, updateBlocks);
		}
		
		private function initBlocks():void {
			for (var r:int = 0; r < rows; r++) {
				for (var c:int = 0; c < cols; c++) {
					var newBlock:Sprite = new Sprite();
					newBlock.name = "block" + r + c;
					var p:Point = new Point(c * blockW, r * blockH);
					newBlock.x = c * (blockW + 1) + 20;
					newBlock.y = r * (blockH + 1) + 20;
					pointArray[newBlock.name] = p;
					
					var bmpd:BitmapData = new BitmapData(blockW, blockH);
					var bmp:Bitmap = new Bitmap(bmpd);
					bmp.name = "myBmp";
					
					newBlock.addChild(bmp);
					addChild(newBlock);
					
					newBlock.addEventListener(MouseEvent.MOUSE_DOWN, onMouseDown);
					newBlock.addEventListener(MouseEvent.MOUSE_UP, onMouseUp);					
				}
			}			
		}
		
		private function updateBlocks(e:Event):void {
			var srcBmpd:BitmapData = new BitmapData(camW, camH);
			srcBmpd.draw(video);
			for (var r:int = 0; r < rows; r++) {
				for (var c:int = 0; c < cols; c++) {
					var b_mc:Sprite = this.getChildByName("block" + r + c) as Sprite;
					var bmp:Bitmap = b_mc.getChildByName("myBmp") as Bitmap;
					var p:Point = pointArray[b_mc.name];
					
					bmp.bitmapData.copyPixels(srcBmpd, new Rectangle(p.x, p.y, blockW, blockH), new Point());
				}
			}
		}
		
		private function onMouseDown(e:MouseEvent):void {
			Sprite(e.currentTarget).alpha = 0.4;
			Sprite(e.currentTarget).startDrag();
		}
		
		private function onMouseUp(e:MouseEvent):void {
			Sprite(e.currentTarget).alpha = 1;
			Sprite(e.currentTarget).stopDrag();
		}
	

	}// eof class	
}// eof package